# gitlab ci templates default pipeline
# author: sbassett@wikimedia.org

# mr commit message linting template
include:
  - project: 'repos/ci-tools/commit-message-validator'
    ref: v2.0.0
    file: '/templates/lint-merge-request.yml'

stages:
  - test

# lint yaml files under test stage
lint-yaml-files:
  stage: test
  image: docker-registry.wikimedia.org/python3-bullseye:0.0.2-20231126
  variables:
    PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

  cache:
    paths:
      - .cache/pip
      - venv/

# Installs and config
  before_script:
    - |
      apt-get update -yqq && apt-get install -yqq git python3-venv
      python3 -m venv env
      source env/bin/activate
      python3 -m pip install --upgrade setuptools
      python3 -m pip install yamllint

  script:
    - |
      file_list=$(git diff-tree --no-commit-id --name-only -r --diff-filter=d $CI_COMMIT_SHA -- *.{yml,yaml})
      if [ -n "$file_list" ]; then
        echo "Linting modified or added YAML files..."
        for f in $file_list; do
          if yamllint --no-warnings -d relaxed "$f"; then
            echo "[✔]  $f passed yamllint."
            exit 0
          else
            echo "[✘]  $f does not appear to be a valid YAML file!"
            exit 1
          fi
        done
      else
        echo "No modified or added YAML files in this commit."
      fi

workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
    - if: $CI_COMMIT_REF_PROTECTED
